/* Copyright (C) 2010 Stephane Rochoy
 * 
 * This file is part of Weapon Factory.
 * 
 * Weapon Factory is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Weapon Factory is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Weapon Factory. If not, see <http://www.gnu.org/licenses/>.
 */
#include "FrameListener.hh"

using namespace WeaponFactory;

FrameListener::FrameListener(InputDispatcher*    inputDispatcher,
			     Core*          gameState)
  : mInputDispatcher(inputDispatcher),
    mCore(gameState)
{
}

bool
FrameListener::frameStarted(const Ogre::FrameEvent &evt) 
{
  if (!Ogre::FrameListener::frameStarted(evt)) {
    return false; // Stop rendering.
    // NOTREACHED
  }
  mInputDispatcher->capture();
  mCore->addTime(evt.timeSinceLastFrame);
  return mCore->isRunning(); 
}
