/* Copyright (C) 2010 Stephane Rochoy
 * 
 * This file is part of Weapon Factory.
 * 
 * Weapon Factory is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Weapon Factory is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Weapon Factory. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef FRAMELISTENER_HH
#define FRAMELISTENER_HH
#include <Ogre.h>
#define OIS_DYNAMIC_LIB
#include <OIS.h>

#include "InputDispatcher.hh"
#include "Core.hh"

namespace WeaponFactory {
  /** Listen to frame events.
   *  Is responsible for capturing input events through InputDispatcher::capture()
   *  when a new frame is started. Is also responsible for adding time to the
   *  MapView and to all entities.
   */
  class FrameListener 
    : public Ogre::FrameListener {
  public:
    FrameListener(InputDispatcher* inputDispatcher,
		  Core*       gameState);
    bool frameStarted(const Ogre::FrameEvent &evt);

  protected:
    Core*          mCore;
    InputDispatcher*    mInputDispatcher;
  };
}
#endif // FRAMELISTENER_HH
