/* Copyright (C) 2010 Stephane Rochoy
 * 
 * This file is part of Weapon Factory.
 * 
 * Weapon Factory is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Weapon Factory is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Weapon Factory. If not, see <http://www.gnu.org/licenses/>.
 */
#include <fstream>
#include "GameInputListener.hh"
#include "Exception.hh"
#include "input-functors/EndGameFunctor.hh"
#include "input-functors/PopupMenuFunctor.hh"

using namespace WeaponFactory;

GameInputListener::GameInputListener(std::string keyBindingsPath, 
                                     Core*  gameState)
  : InputListener(gameState) 
{
  /*
  // Ending game:
  this->registerAction("end-game",            Actions::endGame);
  // Shell:
  this->registerAction("toggle-shell-window", Actions::toggleShellWindow);
  // Camera:
  this->registerAction("camera-up",           Actions::cameraUp);
  this->registerAction("camera-down",         Actions::cameraDown);
  this->registerAction("camera-left",         Actions::cameraLeft);
  this->registerAction("camera-right",        Actions::cameraRight);
  // Trooper:
  this->registerAction("move-trooper",        Actions::moveTrooper);
  */
  this->registerAction("end-game", new EndGameFunctor(gameState));
  this->registerAction("popup-menu", new PopupMenuFunctor(0));
  //this->registerAction("toggle-shell-window", new ToggleWindowFunctor(0));
  this->loadKeyBindings(keyBindingsPath);
}
