/* Copyright (C) 2010 Stephane Rochoy
 * 
 * This file is part of Weapon Factory.
 * 
 * Weapon Factory is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Weapon Factory is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Weapon Factory. If not, see <http://www.gnu.org/licenses/>.
 */
#include "MapView.hh"

using namespace WeaponFactory;

MapView::MapView(Ogre::SceneNode* cameraNode)
  : mCameraNode(cameraNode),
    mTranslationVector(Ogre::Vector3::ZERO),
    mTranslationScale(15000.0f) {
}

MapView::~MapView() {
}

void
MapView::addTime(Ogre::Real offset) {
  using namespace Ogre;
  mCameraNode->translate(mTranslationVector * offset, Node::TS_LOCAL);
  mTranslationVector = Vector3::ZERO;
}

void
MapView::up(void) {
  mTranslationVector.z = -mTranslationScale;
}

void
MapView::down(void) {
  mTranslationVector.z = mTranslationScale;
}

void
MapView::left(void) {
  mTranslationVector.x = -mTranslationScale;
}

void
MapView::right(void) {
  mTranslationVector.x = mTranslationScale;
}
