/* Copyright (C) 2010 Stephane Rochoy
 * 
 * This file is part of Weapon Factory.
 * 
 * Weapon Factory is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Weapon Factory is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Weapon Factory. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef MOVESTATE_HH
#define MOVESTATE_HH
#include <Ogre.h>

namespace WeaponFactory {
  /** Hold the state of the movement of an entity.
   */
  class MoveState {
  public:
    MoveState();
    MoveState(Ogre::SceneNode* node);
    void addTime(Ogre::Real offset);
    bool isMoving(void);
    void queueMove(Ogre::Vector3 hop);
    void cancelAllMoves(void);
  protected:
    void setupNextHop(void);

    Ogre::SceneNode*          mNode;
    Ogre::Vector3             mCurrentPosition;
    Ogre::Vector3             mDestination;
    Ogre::Vector3             mDirection;
    Ogre::Real                mDistance;
    Ogre::Real                mSpeed;
    std::deque<Ogre::Vector3> mHops;
  };
}
#endif // MOVESTATE_HH
