/* Copyright (C) 2010 Stephane Rochoy
 * 
 * This file is part of Weapon Factory.
 * 
 * Weapon Factory is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Weapon Factory is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Weapon Factory. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef USERINTERFACE_HH
#define USERINTERFACE_HH
#include <CEGUI.h>
#include <OgreCEGUIRenderer.h>
#include <Ogre.h>

#include "Core.hh"

namespace WeaponFactory {
  class UserInterface {
  public:
    UserInterface(Ogre::RenderWindow*, Ogre::SceneManager*, Core*);
    bool onToggleConsole(const CEGUI::EventArgs&);
    bool onExit(const CEGUI::EventArgs&);

  protected:
    CEGUI::OgreCEGUIRenderer* mRenderer;
    Core*                     mCore;
  };
}
#endif // USERINTERFACE_HH
